package meerkat.mixer;

import meerkat.protobuf.Crypto;
import meerkat.protobuf.Mixing;

import java.io.OutputStream;


/**
 * Created by Tzlil on 1/18/2016.
 * container for meerkat.mixer.network.mix result.
 */
public class MixerOutput {
    private final Mixing.Mix2Proof[][] proofs;
    private final Crypto.RerandomizableEncryptedMessage[][] encryptedMessages;
    private final int logN;

    /**
     * constructor
     * @param logN log (base 2) of the number of votes
     * @param encryptedMessages at level 0 , contains the original encrypted votes
     *                          at each other level contains the re encrypted votes
     * @param proofs in each cell (level,switch) contains the match zero knowledge proof
     */
    public MixerOutput(int logN, Mixing.Mix2Proof[][] proofs,
                       Crypto.RerandomizableEncryptedMessage[][] encryptedMessages) {
        this.proofs = proofs;
        this.encryptedMessages = encryptedMessages;
        this.logN = logN;
    }

    public Mixing.Mix2Proof[][] getProofs() {
        return proofs;
    }

    public Crypto.RerandomizableEncryptedMessage[][] getEncryptedMessages() {
        return encryptedMessages;
    }

    public int getLogN() {
        return logN;
    }

    public int getNumLayers() {
        return 2 * logN - 1;
    }
}
